/* 페이징 관련 변수 */
let appBoardTotalCount   = 0;
let appBoardTotalPages   = 0;

/*aggird*/
let appBoardAgGridData = [];

let appBoardSelectId = "";

/****************************************************************************
 * 검색 날짜 설정
 //(A:오늘, B:3일, C:7일, D:최근30일, E:최근90일, F:이번달, G:올해, H:지난주, I:지난달)
 ****************************************************************************/
function fn_appBoardSetDate(param){
    if("A"==param){
        // 오늘
        let toDate = new Date();
        let year  = toDate.getFullYear();
        let month = toDate.getMonth() + 1;
        let day   = toDate.getDate();

        if(month < 10) month = "0" + month;
        if(day < 10) day = "0" + day;

        appBoardSearchStartDate = year+'-'+month+'-'+day;
        appBoardSearchEndDate   = year+'-'+month+'-'+day;
    }
    else if("B"==param){
        // 3일
        // 검색 종료일자
        let toDate = new Date();
        let year  = toDate.getFullYear();
        let month = toDate.getMonth() + 1;
        let day   = toDate.getDate();

        if(month < 10) month = "0" + month;
        if(day < 10) day = "0" + day;

        appBoardSearchEndDate   = year+'-'+month+'-'+day;

        // 검색 시작일자
        toDate.setDate(toDate.getDate() - 3);
        year  = toDate.getFullYear();
        month = toDate.getMonth() + 1;
        day   = toDate.getDate();

        if(month < 10) month = "0" + month;
        if(day < 10) day = "0" + day;

        appBoardSearchStartDate = year+'-'+month+'-'+day;
    }
    else if("C"==param){
        // 이번주
        // 검색 종료일자
        let toDate = new Date();
        let year  = toDate.getFullYear();
        let month = toDate.getMonth() + 1;
        let day   = toDate.getDate();

        if(month < 10) month = "0" + month;
        if(day < 10) day = "0" + day;

        appBoardSearchEndDate   = year+'-'+month+'-'+day;

        // 검색 시작일자
        toDate.setDate(toDate.getDate() - 7);
        year  = toDate.getFullYear();
        month = toDate.getMonth() + 1;
        day   = toDate.getDate();

        if(month < 10) month = "0" + month;
        if(day < 10) day = "0" + day;

        appBoardSearchStartDate = year+'-'+month+'-'+day;
    }
    else if("D"==param){
        // 최근30일
        let toDate = new Date();
        let year  = toDate.getFullYear();
        let month = toDate.getMonth() + 1;
        let day   = toDate.getDate();

        if(month < 10) month = "0" + month;
        if(day < 10) day = "0" + day;

        //최근30일
        toDate.setDate(toDate.getDate() - 30);
        startYear  = toDate.getFullYear();
        startMonth = toDate.getMonth() + 1;
        startDay   = toDate.getDate();

        if(startMonth < 10) startMonth = "0" + startMonth;
        if(startDay < 10) startDay = "0" + startDay;

        appBoardSearchStartDate = startYear+'-'+startMonth+'-'+startDay;
        appBoardSearchEndDate   = year+'-'+month+'-'+day;

    }
    else if("E"==param){
        // 최근90일
        // 검색 종료일자
        let toDate = new Date();
        let year  = toDate.getFullYear();
        let month = toDate.getMonth() + 1;
        let day   = toDate.getDate();

        if(month < 10) month = "0" + month;
        if(day < 10) day = "0" + day;

        appBoardSearchEndDate   = year+'-'+month+'-'+day;

        // 검색 시작일자
        toDate.setDate(toDate.getDate() - 90);
        year  = toDate.getFullYear();
        month = toDate.getMonth() + 1;
        day   = toDate.getDate();

        if(month < 10) month = "0" + month;
        if(day < 10) day = "0" + day;

        appBoardSearchStartDate = year+'-'+month+'-'+day;
    }
    else if("F"==param){
        //F:이번달
        // 검색 종료일자
        let toDate = new Date();
        let year  = toDate.getFullYear();
        let month = toDate.getMonth() + 1;
        let day   = toDate.getDate();

        if(month < 10) month = "0" + month;
        if(day < 10) day = "0" + day;

        appBoardSearchEndDate   = year+'-'+month+'-'+day;

        // 검색 시작일자
        appBoardSearchStartDate = year+'-'+month+'-01';
    }
    else if("G"==param){
        // G:올해
        // 검색 종료일자
        let toDate = new Date();
        let year  = toDate.getFullYear();
        let month = toDate.getMonth() + 1;
        let day   = toDate.getDate();

        if(month < 10) month = "0" + month;
        if(day < 10) day = "0" + day;

        appBoardSearchEndDate   = year+'-'+month+'-'+day;

        // 검색 시작일자
        appBoardSearchStartDate = year+'-01-01';
    }
    else if("H"==param){
        // H:지난주, I:지난달
        // 검색 종료일자
        let toDate = new Date();
        let year  = toDate.getFullYear();
        let month = toDate.getMonth() + 1;
        let day   = toDate.getDate();

        if(month < 10) month = "0" + month;
        if(day < 10) day = "0" + day;

        appBoardSearchEndDate   = year+'-'+month+'-'+day;

        // 검색 시작일자
        appBoardSearchStartDate = year+'-01-01';
    }
    else if("I"==param){
        // I:지난달
        // 검색 종료일자
        let toDate = new Date();
        let year  = toDate.getFullYear();
        let month = toDate.getMonth() + 1;
        let day   = toDate.getDate();

        if(month < 10) month = "0" + month;
        if(day < 10) day = "0" + day;

        appBoardSearchEndDate   = year+'-'+month+'-'+day;

        // 검색 시작일자
        appBoardSearchStartDate = year+'-01-01';
    }

    $("#appBoardSearchStartDate").val(appBoardSearchStartDate).trigger("change");
    $("#appBoardSearchEndDate").val(appBoardSearchEndDate).trigger("change");
}


/****************************************************************************
 * 콘텐츠 정보 리스트 조회
 ****************************************************************************/
function fn_selectListAppBoardJson(){
    let formData = new FormData();
    formData.append("menuClass", menuClass);
    formData.append("appBoardSearchKeywordParam", appBoardSearchKeywordParam);
    formData.append("appBoardCategoryName", appBoardCategoryName);
    formData.append("appBoardSort", appBoardSort);
    formData.append("appBoardDir", appBoardDir);
    formData.append("appBoardStart", appBoardStart);
    formData.append("appBoardLimit", appBoardLimit);
    formData.append("appBoardSearchStartDate", appBoardSearchStartDate);
    formData.append("appBoardSearchEndDate", appBoardSearchEndDate);
    formData.append("appBoardSearchDateType", appBoardSearchDateType);

    $.ajax({
        url: encodeURI('/webappboard/selectListAppBoard.do'),
        data: formData,
        dataType: "json",
        processData: false,
        contentType: false,
        type: 'POST',
        async: true,
        success: function(data){
            if('0'==data.msgCode){
                // 페이징 처리
                appBoardTotalCount  = data.totalCount;
                //$("#txt_noticeTotalCount").text(noticeTotalCount);

                appBoardTotalPages = Math.ceil(appBoardTotalCount/appBoardLimit);

                // 리스트 조회
                appBoardAgGridData = data.rows;
                appBoardGridOptions.api.setRowData(appBoardAgGridData);

                if(0<data.rows.length){
                    //페이징 처리
                    window.pagObj = $('#appBoardPagination').twbsPagination({
                        startPage    : ((appBoardStart/appBoardLimit)+1),
                        totalPages   : (appBoardTotalPages==0)?1:appBoardTotalPages,
                        visiblePages : 10,
                        initiateStartPageClick: false,
                        prev         : '<img src="/image/web/page_navigation_arrow.svg" alt="prev"/>',
                        next         : '<img src="/image/web/page_navigation_arrow.svg" alt="next"/>',
                        first        : '',
                        last         : '',
                        onPageClick: function (event, page) {
                            fn_appBoardPagination(page);
                        }
                    }).on('page', function (event, page) {
                        //console.info(page + ' (from event listening)');
                    });
                }
                else{

                }
            }
            else{
                modalEvent.danger("조회 오류", data.msgDesc);
            }
        },
        error : function(xhr, status, error) {
            modalEvent.danger("조회 오류", "조회 중 오류가 발생하였습니다. 잠시후 다시시도하십시오.");
        },
        beforeSend:function(){
            // 로딩열기
            appBoardGridOptions.api.showLoadingOverlay();
        },
        complete:function(){

        }
    });
}

/****************************************************************************
 * 검색하기
 ****************************************************************************/
function fn_appBoardSearch(param){
    if("A"!=param && "Y"!=selectUseYn){
        modalEvent.warning("", "조회 권한이 없습니다.");
        return false;
    }

    fn_appBoardPaginReset();

    appBoardSearchKeywordParam = $("#appBoardSearchKeyword").val();

    appBoardCategoryName = $("#appBoardCategoryName").val();

    appBoardSearchDateType  = $("#appBoardSearchDateType").val();
    appBoardSearchStartDate = $("#appBoardSearchStartDate").val();
    appBoardSearchEndDate   = $("#appBoardSearchEndDate").val();

    fn_selectListAppBoardJson();
}


/****************************************************************************
 * 초기화하기
 ****************************************************************************/
function fn_appBoardReset(){
    fn_appBoardSetDate('D');
    $("#appBoardSearchDateType option:eq(0)").prop("selected", true);

    $("#appBoardSearchKeyword").val("");

    fn_appBoardSearch();
}

/****************************************************************************
 * 페이징 처리
 ****************************************************************************/
function fn_appBoardPagination(param){
    appBoardStart = (parseInt(param)-1)*appBoardLimit;

    fn_selectListAppBoardJson();
}

/****************************************************************************
 * 페이징 리셋
 ****************************************************************************/
function fn_appBoardPaginReset(){
    appBoardSearchKeywordParam = '';

    appBoardStart        = 0;
    appBoardLimit        = 100;
    appBoardTotalCount   = 0;
    appBoardTotalPages   = 0;

    //페이징 초기화
    if($("#appBoardPagination").data("twbs-pagination")){
        $("#appBoardPagination").twbsPagination("destroy");
    }
}

/****************************************************************************
 * 콘텐츠 삭제
 ****************************************************************************/
function fn_deleteAppBoard(){
    if("Y"!=deleteUseYn){
        modalEvent.warning("", "삭제 권한이 없습니다.");
        return false;
    }

    if(!appBoardSelectId){
        modalEvent.warning("", "삭제할 대상을 선택하세요.");
        return false;
    }

    modalEvent.info("삭제", "선택한 보드 정보를 삭제하시겠습니까?", function(){
        let formData = new FormData();
        formData.append("menuClass", menuClass);
        formData.append("selectId", appBoardSelectId);

        $.ajax({
            url: encodeURI('/webappboard/deleteAppBoard.do'),
            data: formData,
            dataType: "json",
            processData: false,
            contentType: false,
            type: 'POST',
            async: true,
            success: function(data){
                if('0'==data.msgCode){
                    modalEvent.success("삭제 성공", data.msgDesc, function(){
                        fn_appBoardOk();
                    });
                }
                else{
                    modalEvent.danger("삭제 오류", data.msgDesc);
                }
            },
            error : function(xhr, status, error) {
                modalEvent.danger("삭제 오류", "삭제 중 오류가 발생하였습니다. 잠시후 다시시도하십시오.");
            },
            beforeSend:function(){

            },
            complete:function(){

            }
        });
    });
}

/****************************************************************************
 * 검색 엔터 이벤트
 ****************************************************************************/
function fn_appBoardEnter(e){
    if(e.which){
        // 파이어폭스
        if(13 == e.which) {
            //로그인 액션 스크립트
            fn_appBoardSearch();
        }
    }
    else{
        // 윈도우, 사파리, 크롬
        if(13 == event.keyCode) {
            //로그인 액션 스크립트
            fn_appBoardSearch();
        }
    }
}

/****************************************************************************
 * 정렬 이벤트
 ****************************************************************************/
function fn_alignBoard(param, param2){
    let align = "";

    if("A"==param){
        align = "오늘";

        fn_appBoardSetDate('A');
    }
    else if("B"==param){
        align = "최근30일";

        fn_appBoardSetDate('D');
    }
    else if("C"==param){
        align = "최근90일";

        fn_appBoardSetDate('E');
    }
    else if("D"==param){
        align = "이번주";

        fn_appBoardSetDate('C');
    }
    else if("E"==param){
        align = "이번달";

        fn_appBoardSetDate('F');
    }
    else if("F"==param){
        align = "올해";

        fn_appBoardSetDate('G');
    }
    else if("G"==param){
        align = "지난주";

        fn_appBoardSetDate('H');
    }
    else if("H"==param){
        align = "지난달";

        fn_appBoardSetDate('I');
    }
    else{
        align = "";
    }
    $("#appBoardSearchDateType").val(param);
    $("#appBoardSearchDateType").siblings("button").text(align);
}

/****************************************************************************
 * 완료
 ****************************************************************************/
function fn_appBoardOk(){
    fn_appBoardReset();
}

/****************************************************************************
 * 등록 화면으로 이동.
 ****************************************************************************/
function fn_insertAppBoardIntro(){
    if("Y"==insertUseYn){
        let pagingParam = "?menuClass="+menuClass;
        fn_leftFormAction("/webappboard/insertBoardIntro.do"+pagingParam);
    }else{
        modalEvent.warning("", "등록 권한이 없습니다.");
        return false;
    }

}

/****************************************************************************
 * 수정 화면으로 이동.
 ****************************************************************************/
function fn_updateAppBoardIntro(muAppBoardId){
    if("Y"==updateUseYn){
        let pagingParam = "?menuClass="+menuClass;
        pagingParam    += "&muAppBoardId="+muAppBoardId;
        fn_leftFormAction("/webappboard/updateBoardIntro.do"+pagingParam);
    }else{
        modalEvent.warning("", "수정 권한이 없습니다.");
        return false;
    }
}
function thumbnailCellRenderer(params) {
    if(!params.value)
        return
    else
        return `<img src="${params.value.replace("C:", "")}" width="40" height="40" alt="Thumbnail">`;
}

let appBoardColumnDefs = [
    {field: "checkbox", headerName:"", minWidth:55, maxWidth:55, headerCheckboxSelection: true, checkboxSelection: true},
    /* {field: "rowNum", headerName:"번호", minWidth:80,maxWidth:80, sortable: false}, */
    {field: "rowNum", headerName:"번호", minWidth:60,sortable: false, cellStyle:{textAlign: 'center'}},
    {field: "title", headerName:"제목", minWidth:300, cellStyle:{cursor: 'pointer', color:'#3985EA'}},
    {field: "content", headerName:"내용",minWidth:500},
    {field: "contentCount", headerName:"컨텐츠 수",minWidth:250, maxWidth:250},
    {field: "exposedYn", headerName:"메인 홈 노출여부",minWidth:200, maxWidth:200},
    {field: "writeDate", headerName:"등록일",minWidth:150, maxWidth:150},
];

// let the grid know which columns and what data to use
let appBoardGridOptions = {
    suppressRowTransform: true,
    columnDefs: appBoardColumnDefs,
    defaultColDef: {		// 리스트 기본 설정
        flex: 1,
        sortable: true,		//정렬 여부
        resizable: true,	//리사이즈
        editable: true,	// 그리드에서 데이터 수정
        cellStyle:{textAlign:'left',fontSize:'14px',padding:'0'},
        //suppressSizeToFit:true,		//자동 맞춤
        //enableRowGroup: true,		// 그룹 묶음
        enablePivot: true,
        enableValue : true
    },
    //suppressMultiSort:true,  //단일솔트 true가 단일, false가 다중 shift + sort 시
    headerHeight : 41, // header 높이
    rowHeight : 41, // row 높이
    rowData : appBoardAgGridData,
    suppressRowClickSelection : true, // 로우 클릭시 체크박스 선택 true no, false yes
    localeText : {
        noRowsToShow : '조회 결과가 없습니다.'
    }, //데이터 없을 시 나오는 문구
    rowSelection : 'multiple', // row 다중 선택
    debug : false,
    onCellClicked: function(event){ //셀 클릭 이벤트
        /* alert(event.column.colId); */
        if('title'==event.column.colId){
            fn_updateAppBoardIntro(event.data.muAppBoardId);
        }
    },
    onSelectionChanged: function(event){ //체크박스 선택
        let selectRows = [];
        selectRows = event.api.getSelectedRows();

        appBoardSelectId = '';
        for(let i=0; i<selectRows.length; i++){
            appBoardSelectId += selectRows[i].muAppBoardId + ",";
        }
        appBoardSelectId = appBoardSelectId.substring(0, appBoardSelectId.lastIndexOf(','));
    },
    onSortChanged: function(event){
        //정렬
        appBoardSort = ''; //기존 정렬 초기화
        let columnArr = event.columnApi.getColumnState();
        if(0<columnArr.length){
            //sort index 순으로 재정렬
            columnArr.sort(function(a,b){
                return a.sortIndex - b.sortIndex;
            });

            let nullCnt = 0;
            for(let i=0; i<columnArr.length; i++){
                let gridSortModel = columnArr[i].colId;
                let gridSort = columnArr[i].sort;

                if(gridSort != null){
                    appBoardStart = 0;
                    appBoardSort += gridSortModel+' '+ gridSort + ',';
                }
                else{
                    nullCnt++;
                    if(nullCnt == columnArr.length){
                        appBoardSort = '';
                        appBoardDir = '';
                        appBoardStart = 0;
                    }
                }
            }
        }
        appBoardSort = appBoardSort.substring(0,appBoardSort.lastIndexOf( ",")); //맨끝 콤마 지우기

        fn_appBoardSearch();
    }
};

// lookup the container we want the Grid to use
let appBoardGridDiv = document.querySelector('#appBoardGrid');

// create the grid passing in the div to use together with the columns & data we want to use
new agGrid.Grid(appBoardGridDiv, appBoardGridOptions);





/****************************************************************************
 * 페이지 init
 ****************************************************************************/
function fn_pageInit(){
    // 날짜 datepicker
    fn_searchDatePicker("#divAppBoardSearchStartDate", "#divAppBoardSearchEndDate");

    if(!appBoardSearchStartDate&&!appBoardSearchEndDate){
        // 검색 오늘날짜 셋팅
        fn_appBoardSetDate('D');
    }else{
        $("#appBoardSearchStartDate").val(appBoardSearchStartDate).trigger("change");
        $("#appBoardSearchEndDate").val(appBoardSearchEndDate).trigger("change");
    }

    // 초기 페이징 처리
    $("#appBoardSearchKeyword").val(appBoardSearchKeywordParam);

    fn_appBoardSearch("A");
}

/****************************************************************************
 * 페이지 event
 ****************************************************************************/
function fn_pageEvent(){
    // 검색 input
    $(document).on('keypress', '#appBoardSearchKeyword', function(e) {
        fn_appBoardEnter(e);
    });

    // 검색 조회 버튼
    $("#btnSearchAppBoard").click(function () {
        fn_appBoardSearch();
    });

    // 콘텐츠 등록 팝업 버튼
    $("#btnInsertAppBoard").click(function () {
        fn_insertAppBoardIntro();
    });

    // 콘텐츠 삭제 버튼
    $("#btnDeleteAppBoard").click(function () {
        fn_deleteAppBoard();
    });

    // 기간 선택 콤보 이벤트
    const target = $("#appBoardSearchDateType").siblings("ul.select_option_list");
    target.find("li.option_list_item").click(function () {
        let selectIdArr = $(this).prop("id").split('_');
        let selectId    = selectIdArr[1];
        let selectName  = $(this).text();

        $(this).parent().siblings("button").text(selectName);
        $(this).parent().siblings("input").val(selectId);

        fn_alignBoard(selectId);
    });

    // 카테고리 선택 콤보 이벤트
    const categoryTarget = $("#appBoardCategoryName").siblings("ul.select_option_list");
    categoryTarget.find("li.option_list_item").click(function () {
        let selectIdArr = $(this).prop("id").split('_');
        let selectId    = selectIdArr[1];
        let selectName  = $(this).text();

        if(selectId.match("ALL")){
            selectId = '';
        }
        $(this).parent().siblings("button").text(selectName);
        $(this).parent().siblings("input").val(selectId);
    });
}

$(function(){
    // 페이지 init
    fn_pageInit();

    // 페이지 event
    fn_pageEvent();
});